function [] =ders4()
%% Adding noise to image

%Salt and pepper noise
a=imread('1.jpg');
b=imnoise(a,'salt & pepper'); 
imshowpair(a, b, 'montage')
title('salt & pepper');

%Impulse noise
x=imread('2.jpg');
y=rgb2gray(x);
[m,n]=size(y);
new= randint(m,n,[0 255]);
salt =250;
y(new>=salt) = 255; 
figure,
imshowpair(x, y, 'montage')
title('manually added salt noise');

% Gaussian noise
g=imread('3.jpg');
gray=rgb2gray(g);
gray=im2double(gray);
% gn=imnoise(g,'gaussian');
% imshowpair(g, gn, 'montage');
% title('Gaussian noise');
mean=0;
variance=0.05;
gray = gray+ (sqrt(variance)*randn(size(gray)) + mean);
imshowpair(g, gray, 'montage');
%%
average1 = 1/10*ones(10,1);%by hand
waverage=1/16*[1 2 1
               2 4 2
               1 2 1]
average=fspecial('average',[20 20]);

gbox = imboxfilt(g,11);
imshowpair(g, gbox, 'montage');
title('Box Filter');                 

im=imread('3.jpg');
filter=fspecial('gaussian',30, 30);

corr = imfilter(im,filter,'replicate'); %corr = imfilter(im,filter,'conv')
corr2=conv2(rgb2gray(im),average);
imshowpair(im, corr, 'montage');
title('Filter image with Gauss');
figure,
imshowpair(im, corr2, 'montage');
title('Filter image with Gauss using corr2');

%% 2D Cross correlation
tar=imread('4.jpg');
targ=rgb2gray(tar);
temp=imread('temp.jpg');
tempg=rgb2gray(temp);
cc=normxcorr2(tempg,targ);
figure, imshow(cc)
figure, surf(c), shading flat
[max_cc,imax]=max(abs(cc(:)));
[ypeak,xpeak]=ind2sub(size(cc),imax(1));
best_row=ypeak-(size(tempg,1)-1);
best_col=xpeak-(size(tempg,2)-1);
figure, imshow(tar)
m=(size(tempg,1)-1)
n=(size(tempg,2)-1)
imrect(gca, [best_col  best_row n m])

%%
% Apply Gaussian Smoothing Filters to Images
im=imread('3.jpg');
blur1 = imgaussfilt(im,2);
blur2 = imgaussfilt(im,4);
blur3 = imgaussfilt(im,8);
figure, 
subplot(1,3,1)
imshow(blur1)
title('sigma=2');
subplot(1,3,2)
imshow(blur2)
title('sigma=4');
subplot(1,3,3)
imshow(blur3)
title('sigma=8');

%%  parameters effect
hsize = 10;
sigma = 5;
h = fspecial('gaussian', hsize, sigma);
mesh(h);
% surf(h)
% imagesc(h);

%% Spatial Resolution and Color
im=imread('3.jpg');
R=im(:,:,1);
G=im(:,:,2);
B=im(:,:,3);
subplot(1,3,1), imshow(R)
title('R chanel')
subplot(1,3,2), imshow(G)
title('G chanel')
subplot(1,3,3), imshow(B)
title('B chanel')
Rnew=imfilter(R,h);
Gnew= imfilter(G,h);
Bnew= imfilter(B,h);
figure,imshowpair(G, Gnew, 'montage');
rgbG = cat(3,R,Gnew,B);
figure,imshowpair(im,rgbG, 'montage');

figure,imshowpair(R, Rnew, 'montage');
rgbR = cat(3,Rnew,G,B);
figure,imshowpair(im,rgbR, 'montage');

figure,imshowpair(B, Bnew, 'montage');
rgbB = cat(3,R,G,Bnew);
figure,imshowpair(im,rgbB, 'montage');


%Lab Color Representation
colorimage=imread('4.jpg');
C = makecform('srgb2lab');
B = applycform(colorimage,C)
L=B(:,:,1);
a=B(:,:,2);
b=B(:,:,3);
figure, subplot(1,3,1) 
        imshow(L) 
         title('L channel')
         subplot(1,3,2) 
         imshow(a) 
         title('a channel')
         subplot(1,3,3)
         imshow(b) 
         title('b channel')
  
Lnew=imfilter(L,h);
anew= imfilter(a,h);
bnew= imfilter(b,h);

figure, subplot(1,3,1) 
        imshow(Lnew) 
         title('Lnew channel')
         subplot(1,3,2) 
         imshow(anew) 
         title('anew channel')
         subplot(1,3,3)
         imshow(bnew) 
         title('bnew channel')


%% sharpening

% Median filter
a=imread('2.jpg');
b=imnoise(a,'salt & pepper'); 
imshow(b)
image= medfilt2(rgb2gray(b));
subplot(121);imshow(b);
subplot(122);imshow(image);


end

